/*
 * Created on 10.11.2004
 *
 * SVN header information:
 *  $Author: LBST-PF-3\orahn $
 *  $Rev: 2434 $
 *  $Date: 2006-09-12 12:31:50 +0200 (Di, 12 Sep 2006) $
 *  $Id: PirolCsvDatasetDataSource.java 2434 2006-09-12 10:31:50Z LBST-PF-3\orahn $s
 */
package de.fhOsnabrueck.jump.pirol.datasources.pirolCSV;

import java.awt.Frame;
import java.util.HashMap;
import java.util.Map;

import com.vividsolutions.jump.io.datasource.Connection;
import com.vividsolutions.jump.io.datasource.DataSource;

/**
 * @author Ole Rahn
 *
 * FH Osnabrck - University of Applied Sciences Osnabrck
 * Project PIROL 2005
 * Daten- und Wissensmanagementss
 */
public class PirolCsvDatasetDataSource extends DataSource {

	public static String FILENAME_PROP_KEY 			= DataSource.FILE_KEY;
	
	public static String Y_COORD_COLUMN_PROP_KEY 	= "north/south";
	public static String X_COORD_COLUMN_PROP_KEY 	= "east/west";
	public static String SEPARATOR_PROP_KEY 		= "separator";
	
	private static Frame owner;
	private PirolCsvDatasetConnection connection = null;
	
	public PirolCsvDatasetDataSource(){
		this.setProperties(new HashMap());
	}
	
	public void setYColumn(int column){
	    if (!this.getProperties().containsKey(Y_COORD_COLUMN_PROP_KEY)){
	        this.getProperties().put(Y_COORD_COLUMN_PROP_KEY, new Integer(column));
	    }
	}
	
	public int getYColumn(){
	    if (this.getProperties().containsKey(Y_COORD_COLUMN_PROP_KEY)){
	        return ((Integer)this.getProperties().get(Y_COORD_COLUMN_PROP_KEY)).intValue();
	    }
        return -1;
	}
	
	public void setXColumn(int column){
	    if (!this.getProperties().containsKey(X_COORD_COLUMN_PROP_KEY)){
	        this.getProperties().put(X_COORD_COLUMN_PROP_KEY, new Integer(column));
	    }
	}
	
	public int getXColumn(){
	    if (this.getProperties().containsKey(X_COORD_COLUMN_PROP_KEY)){
	        return ((Integer)this.getProperties().get(X_COORD_COLUMN_PROP_KEY)).intValue();
	    }
	    return -1;
	}
	
	public void setSeparator(String separator){
        String sepEscaped = "";
	        
        for (int i=0; i<PirolCSV_Parser.validSepatators.length; i++){
            if (separator.equals(PirolCSV_Parser.validSepatators[i])){
                sepEscaped = PirolCSV_Parser.validSepatatorNames[i];
            }
        }
        
        if (this.getProperties().containsKey(SEPARATOR_PROP_KEY)){
            this.getProperties().remove(SEPARATOR_PROP_KEY);
        }
	        
	    this.getProperties().put(SEPARATOR_PROP_KEY, sepEscaped);
	}
	
	public String getSeparator(){
	    //System.out.println(this.getClass().getName() + "getSeparator()");
	    if (this.getProperties().containsKey(SEPARATOR_PROP_KEY)){
	        
	        //System.out.println(this.getClass().getName() + "getSeparator(): 2");
	        
	        String sepUnEscaped = "";
	        String separator = (String)this.getProperties().get(SEPARATOR_PROP_KEY); 
	        
	        for (int i=0; i<PirolCSV_Parser.validSepatators.length; i++){
	            if (separator.equals(PirolCSV_Parser.validSepatatorNames[i])){
	                sepUnEscaped = PirolCSV_Parser.validSepatators[i];
	            }
	        }
	        
	        //System.out.println(this.getClass().getName() + "getSeparator(): "+ separator + ", <" + sepUnEscaped + ">");
	        
	        return sepUnEscaped;
	    }
        return "";
	}

	public static void setOwner(Frame owner) {
		PirolCsvDatasetDataSource.owner = owner;
	}
	
	/**
	 * Returns a <code>Connection</code> to a new <code>.csv</code> file.
	 * @return a {@link PirolCsvDatasetConnection}.
	 * @see com.vividsolutions.jump.io.datasource.DataSource#getConnection()
	 */
	public Connection getConnection() {
		if ( connection == null ){
			connection = new PirolCsvDatasetConnection(this, PirolCsvDatasetDataSource.owner);
		}
		return this.connection;
	}
	
	public boolean isWritable() {
		return true;
	}
	
	/**
	 * Specifies if the DataSource is readable. 
	 * @return always <code>true</code>
	 * @see com.vividsolutions.jump.io.datasource.DataSource#isReadable()
	 */
	public boolean isReadable(){
		return true;
	}
	
	public Map getProperties() {
		return super.getProperties();
	}

	public void setProperties(Map properties) {
		super.setProperties(properties);
	}

}
